#!/usr/bin/python
#
# getuf.py version 0.1.2
#
# What it does:
# This script fetchs the daily userfriendly comic (http://www.userfriendly.org)
# This is intended to run once a day. The fetched comic strip is saved in 
# the current directory under a name "uf-YYYYMMDD.gif" where Y,M,D are 
# the values for today's year, month and day
#
# Copyright (c) 2000 by Manuel Bessler <m.bessler@gmx.net>
# 
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Please report errors to me via email. Patches/Contributions are also welcome
#
# BEWARE: This is just a quick hack (and my first Python Script)
# Inspired by get-user_friendly.pl 

from urllib import *
from urlparse import *
import regex

page=urlopen('http://www.userfriendly.org/static/')

found=0
while not found:
	myline=page.readline()
	ret=regex.search("http://www.userfriendly.org/cartoons/archives/.*/.*uf[0-9]+.gif",myline)
	if ret != -1:
		print "--FOUND--"
		found=1
		gifurl=myline[ret:]
		endurl=regex.search(".gif",gifurl)
		if endurl == -1:
			print "Problem: Can't find end of URL string. Giving up."
			exit
		gifurl=gifurl[:endurl+4]
	if myline == '':
		print "Problem: I could not find the URL for the requested cartoon, Sorry. Giving up."
		exit

import time
# get EST
estlocaltime=time.localtime(time.time()-60*60*6)
esttimestr=time.strftime("%Y%m%d",estlocaltime)
urlretrieve(gifurl,'uf-'+esttimestr+'.gif')
